package com.tzld.piaoquan.recommend.feature.domain.ad.base;

import lombok.Data;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;


@Data
public class AdRankItem implements Comparable<AdRankItem> {
    public long adId;
    private double score; // 记录最终的score

    // 预估计算结果
    private double ctr;
    private double cvr;
    private double ecpm1;
    private double ecpm2;
    private double str;
    private double ros;
    private double breakRate;

    // 增加tf打分
    private double tf_ctr;
    private double tf_cvr;
    private double score_type;

    // 初始传入
    private double cpa;
    private double bid1;
    private double bid2;
    private double pidLambda;


    // 记录Item侧用到的特征
    private AdItemFeature itemFeature;
    private String lrSampleString = "";
    private String lrSampleStringOrgin = "";

    // 联盟参数
    private Long mediaId;

    private Long videoId;

    // 扩展参数
    private Map<String, Objects> ext;

    public AdRankItem() {
        //TODO
    }

    private Map<String, Double> rankerScore = new HashMap<>();
    private Map<String, Integer> rankerIndex = new HashMap<>();


    @Override
    public int compareTo(AdRankItem o) {
        if (o == null) {
            return -1;
        }
        if (score > o.score) {
            return -1;
        } else if (score < o.score) {
            return 1;
        } else {
            return 0;
        }
    }


}
